\documentclass[twoside, titlepage]{article}

\usepackage{/usr/local/common/TEXINPUTS/verimagreport}
%\usepackage{verimagreport}



% \usepackage[T1]{fontenc} 


\usepackage{alltt}

%Check if we are compiling under latex or pdflatex
\ifx\pdftexversion\undefined
  \usepackage[dvips]{graphicx}
\else
  \usepackage[pdftex]{graphicx}
  \pdfinfo{ 
    /Title (The Lucky language Reference Manual)
    /Creator (latex)
    /Author  (Erwan Jahier)
  }
\fi

\usepackage{boxedminipage}
\usepackage{amsfonts,amssymb,amsmath}
\usepackage{myxcolor}
%\usepackage{ocamldoc}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% HTMl stuff 
\usepackage{hyperlatex}
%\usepackage[colorlinks, linkcolor=blue,pdftex]{hyperref}

\htmltitle{The Lucky language Reference Manual}
%\htmladdress{erwan.jahier@imag.fr}
\usepackage{frames}
   
\htmldirectory{html}

\setcounter{htmldepth}{3}
\setcounter{htmlautomenu}{3}

%\htmlpanel{1}

% \htmlpanelfield{Table of contents}{tableofcontents}
% \htmlpanelfield{Contents}{hlxcontents}

% \htmlpanelfield{Index}{hlxindex}

%\HlxPrevUrl

\W\usepackage{sequential}
\htmlrule

\newcommand{\bug}{{\bf bug}}
\newcommand{\todo}[1]{{\bf todo:} \emph{#1}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



\input{macros}
  
\title{The Lucky language Reference~Manual}
\author{Erwan Jahier, Pascal Raymond}

\date{Initial version:  March 12, 2004 \\
Last update: \today}

\reportnumber{TR-2004-6}

\shorttitle{The Lucky language Reference~Manual}
\abstract{
The main challenge to automate a testing or a simulation process is
to be able to automate the generation of \emph{realistic} input
sequences to feed the program. In other words, we need an executable
model of the program environment which inputs are the program
outputs, and which outputs are the program inputs.
\\
\\
In the first Lurette prototype -- an automated testing tool of
reactive programs designed at Verimag --, the System Under Test (SUT)
environment behaviour was described by Lustre observers which were
specifying what realistic SUT inputs should be. In other words, the
environment was modelled by a set of (linear) constraints over
Boolean and numeric variables.  The work of Lurette was to solve
those constraints, and to draw a value among the solutions to produce
one SUT input vector.
\\ 
\\
But, from a language expressing power point of view, Lustre observers
happen to be too restrictive, in particular to express sequences of
different testing scenarios, or to have some control on the
probabilistic distribution of the drawn solution.  It was precisely
to overcome those limitations that a new language, Lucky, was
designed. 
\\
\\
A Lucky program is an interpreted automaton whose transitions define
the reactions of the machine. More precisely, each transition is
associated to (1) a set of constraints (a lustre-like formula) that
defines the set of the possible outputs, and (2) a weight that
defines the relative probability for each transitions to be taken,
i.e., to be used to produce the output vector for the current step.
}

\keywords{Reactive systems, validation, automatic test case generation, lurette, lustre}

\reviewers{Nicolas Halbwachs}

%\notes{a note}


%--------------------------------------------------------------------
%--------------------------------------------------------------------
\begin{document}

\maketitlepage



 \vfill
\newpage
\tableofcontents
\newpage

\section{Introduction}

\paragraph{Motivations.}


Synchronous programs~\cite{esterel,lustre,signal} deterministically
produce outputs from input values.  To be able to compile,
synchronous programs need to be fully deterministic.
%
However, sometimes, we want to be able to describe synchronous
systems in a non deterministic manner:

\begin{itemize}
\item if one wants to describe (and simulate) an intrinsically
  non-deterministic system.  A typical example is when one want to
  describe the environment of a reactive program; it can be very
  useful for testing and simulation purposes.
  
\item Another potential use of the animation of non-deterministic code
  is when one wants to simulate partially written reactive programs
  (some components are missing). The idea is then to take advantage of
  program signatures, pre/post conditions, or code chunks to simulate
  those programs the more realisticly as possible, taking into
  account the available constraints, and drawing the non-deterministic
  parts. This can be very useful to simulate and test applications at
  every stage of the development process.
\end{itemize}

We call an \emph{non-deterministic program} such pieces of code that
produce their outputs non-deterministically.  Lucky is a language to
describe such non-deterministic programs.  Basically, it is an interpreted
automaton which transitions are labelled by Boolean expressions. As in
Lustre, expressions are formulas over Boolean and
numeric values\footnote{A restriction is that numeric constraint
  ought to be linear (e.g., $x+y > 3$, but not $x^2+y^2>2$ nor $log~s
  + sin~r > e^s$). }  that define an atomic reaction (in the
synchronous sense).  The key difference with lustre is that those
equations may admit several solutions, hence the first source of
non-determinism.  The second source of non-determinism is due to the
fact that several expressions can be reached from the current
state; the choice is done according to weights that also label
transitions.  Those weights let one assign probabilities to the
different temporal scenarios defined by the automaton.
%
Lucky can be seen as a language to program stochastic processes
(Markov chains).



\paragraph{Plan.}


We first present the Lucky language principles in
Section~\ref{lucky-section}, and give its syntax rules in
Section~\ref{lucky-syntax}. Then, we briefly present the {\tt lucky}
command-line tool in Section~\ref{lucky-command-line}.  Finally, In
Appendix, we provide several commented Lucky programs.





%--------------------------------------------------------------------
%--------------------------------------------------------------------
%--------------------------------------------------------------------
\section{The Lucky language principles}
\label{lucky-section}

% \subsection{Introduction}

A reactive system is an automated system that indefinitely responds
to its environment. We are particularly interested here in control
and embedded applications, where the environment is often the
physical world.  During the development of such systems,
non-determinism is often useful, for describing a partially designed
system and/or its environment.




\subsection{Overview}
We propose a model where a basic qualitative model describing a set of
behaviours is extended with a probabilistic mechanism.
The main features of this model are presented here.

\paragraph{\bf Symbolic state/transition systems.}
The basic qualitative model consists in a very general
state/transition system, characterised by: 

\begin{itemize}
\item a memory: a finite set of variables with no special
restrictions on their domains (to simplify, we will consider here just
Boolean, integer and rational values);
\item an interface: variables are declared as inputs, outputs,
or locals;
\item a finite control structure: an interpreted finite automaton, whose
transitions are representing reactions of the machine. 
\end{itemize}

A global state of the system is then a pair made of the current
control point in the automaton (the {\em control-state}), and a current
valuation of its memory (the {\em data-state}).
Therefore the set of global states is potentially infinite.

\paragraph{\bf Synchronous relations.}
We adopt the synchronous approach for the reactions: all values in
the memory are changing simultaneously when a reaction is performed.
The previous value of the memory corresponds to the source
data-state, and the current value to the next data-state.  The
transitions are labelled with information denoting what are the
possible values of the current memory depending on the current
data-state.  This information is quite general: it is a {\em
relation} between the past and current values of the variables.  In
particular, no distinction is made between uncontrollable (inputs and
past values) and controllable (locals and outputs) variables.
Performing a reaction will consist in finding solutions to such a
formula.  This problem induces a restriction: we suppose that, once
reduced according to the past and input values, the constraints are
solvable by some actual procedure\footnote{concretely, we have
developed a constraint solver for mixed Boolean/linear constraints.}.


\paragraph{\bf Weights instead of probabilistic distribution.}
Since we have to deal with uncontrollable variables, defining a sound
notion of distribution must be done carefully: depending on those
variables, a formula may be infeasible, and thus its actual
probability is zero.  In other terms, if we want to use probabilistic
distributions, we would have to define a reaction as a map from the
tuple $\langle$source state, past values, input values$\rangle$ to a
distribution over the pairs $\langle$controllable values, next
state$\rangle$.  Expressing and exploiting this kind of model would
be too complex. We prefer a pragmatic approach where probabilities
are introduced in a more symbolic way.

The main idea is to keep the distinction between the probabilistic
information and the constraint information. Since constraints are
influencing probabilities (zero or non-zero), this information does
not express the probability to be drawn, but pragmatically, the
probability to be {\em tried}.  In order to emphasise the difference,
we do not use distributions (i.e., set of positive values the sum of
which is 1) but {\em relative weights}.  A relative weight is a
positive rational value, not necessarily less than one, the meaning
of which is only defined relatively to another weight: if two
possible reactions (i.e., the corresponding constraints are both
satisfiable) are labelled respectively with the weights $w$ and $w'$,
then the probability to perform the former is $w/w'$ times the
probability to perform the latter.



\paragraph{\bf Static weights versus dynamic weights.}
The simplest solution is to define weights as constants, but in this
case, the expressive power can be too weak. With such static weights,
the uncontrollable variables qualitatively influence the
probabilities (zero or not, depending on the constraints) but not
quantitatively: the idea is then to define {\em dynamic weights} as
numerical functions of the inputs and the past-values.  Taking
numerical past-values into account can be particularly useful. A good
example is when simulating an {\em alive process} where the system
has a known average life expectancy before breaking down; at each
reaction, the probability to work properly depends {\em numerically}
on an internal counter of the process age.

\paragraph{\bf Transient states.}
For the time being, we have only one notion of state: a state is a
stable control point, and a transition between two states defines an
atomic reaction.  However, we think it may be convenient to introduce
the notion of {\em transient state}, and, as a consequence a notion
of micro-step: a complete reaction is then a sequence of transitions
between two stable states, where all the intermediate states are
transient.  Transient states do not affect the synchronous
interpretation of the variable changes: intuitively, if we abstract
probabilities, a reaction $q \transition{f}{} t \transition{g}{} q'$,
is qualitatively equivalent to $q \transition{f \wedge g}{}$.  In
contrast, transient states affect probabilities, and may be helpful
to express complex conditional relative weights.

\paragraph{\bf Global concurrency.}
Concurrency (i.e., parallel execution) is a central paradigm for
reactive systems. The problem of merging sequential and parallel constructs
has been largely studied: classical solutions are hierarchical automata
``\`a la StateCharts'' \cite{maraninchi92,syncchart96}, or statement-based
languages like Esterel~\cite{esterel:scp}.
Our opinion is that deeply merging sequence and parallelism is a problem of
high-level language, and that it is sufficient to have a notion of global
parallelism: intuitively, local parallelism can always be made global
by adding extra idle states.
As a consequence, concurrency is a top level notion in our model:
a complete system is a set of concurrent automata, each one producing
its own constraints on the resulting global behaviour.


\paragraph{\bf Weights and parallelism.}
In terms of control structures, parallelism corresponds to 
a kind of synchronous product of automata. Transient states
make this ``product''  more complex than a simple Cartesian product,
but do not involve big difficulties. For formulas, the product is simply
the logical ``\emph{and}''.
Unfortunately, there is no obvious way for combining stochastic information:
as they are defined, they are only local information and they may
induce paradoxes when combined into a parallel composition.


   \newcommand{\A}{\mbox{$A/a$}}
   \newcommand{\B}{\mbox{$B$}}
   \newcommand{\X}{\mbox{$X/x$}}
   \newcommand{\Y}{\mbox{$Y$}}
   \newcommand{\AY}{\mbox{$A\wedge Y/a$}}
   \newcommand{\BX}{\mbox{$B\wedge X/x$}}
   \newcommand{\BY}{\mbox{$B\wedge Y$}}
   \begin{figure}[htbf]
   \begin{center}
     \rule{12cm}{0.8pt}\\[8mm]
   \scalebox{0.7}{\input{objs/para}}
   \caption{Weights and parallelism: the parallel composition (\ref{para}a),
   and, assuming that $A \wedge X$ is infeasible, the product solution (\ref{para}b)
   and the arbiter solution (\ref{para}c).}
   \label{para}
     \rule{12cm}{0.8pt}\\
   \end{center}

   \end{figure}

   
   A simple example is shown in Figure~\ref{para}a: the first
   automaton (resp. the second) has the choice between the
   constraints $A$ or $B$ (resp. $X$ or $Y$) both satisfiable. In the
   first automaton, the choice of $A$ has a big weight $a>>1$
   compared to $B$ (1 by default), and in the second one, $X$ has a
   big weight $x>>1$ comparing to $Y$.  Suppose that the data-state
   makes it impossible to satisfy $A \wedge X$, it follows that it is
   impossible to satisfy the stochastic demand of both components.
   There are mainly two ways to solve the problem:

\begin{itemize}
\item Consider that weights are not only local information, but are also 
influencing the parallel composition: for instance, if $a$ is much bigger than 
$x$, that means that the stochastic demand of the first component is much stronger
than the one of the second. The simplest way to implement this notion is to
combine weights with multiplication, as shown in Figure~\ref{para}b. 
\item The problem is treated at the parallel composition level, where
some indications are added to express priority for satisfying stochastic demands.
Intuitively, the components of a parallel composition are treated
sequentially: the first one is perfectly served, according to its own
local weights, then the second is served according to what was decided by the
first one, etc. The order of components is, in general non-deterministic, and
stochastic information may be added to influence it. 
The Figure~\ref{para}c shows a product where
a first fair choice is made to decide which component will ``play'' first
(note that all intermediate states are transient).
\end{itemize}

There is no obvious argument to prefer one solution to another: both are 
consistent, and none is clearly more natural than the other.
As a consequence, we plan to implement
%we have adopted a pragmatic approach:
both and let the user choose between them. 
%
For the time being, only the first one is implemented.

Those two product algorithms are described into more details
in Appendix~\ref{automata-product}. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% LUCKY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand{\integer}{\mathbb{N}}
\newcommand{\relative}{\mathbb{Z}}
\newcommand{\rat}{ \mathbb{Q} }
\newcommand{\boolean}{ \mathbb{B} }

%\paragraph{Variables, types, valuations and formula.}
\subsection{Definitions}

%\paragraph{Data structures}
%~
\newcommand{\FS}{\mbox{$\cal F$}} \newcommand{\Wgt}{\mbox{$\cal W$}}
%\newcommand{\prev}{\mbox{\ominus}}

\paragraph{Variables.}
\label{lucky-vars}
\USMM\ variables are either \emph{input}, \emph{output},
\emph{local}, or \emph{previous}: $V = V_i \uplus V_o \uplus V_l
\uplus V_p$.  The previous variables are meant to refer to previous
values of the other variables in $V_{\setminus p} = V_i \uplus V_o
\uplus V_l$.  Each previous variable is denoted by $\pre v$ where $v
\in V_{\setminus p}$.  Moreover, each variable in $V_{\setminus p}$
is defined with a default value: the value just before the first
reaction.  Local variables can be seen as output variables that are
hidden from the outside. 

%  The typing function, $Type : V \rightarrow
% \{\boolean, \relative, \rat\}$ associates a definition domain with
% each variable: Boolean, integer or rational; obviously, $Type(v) =
% Type(\pre v)$.


% For the sake of (formula) conciseness, we also introduce a concept of
% \emph{mode} attached to controllable variables: in the \emph{stable mode},
% unconstrained variables are bound to their previous value; in
% the \emph{unstable mode}, unconstrained variables are drawn from
% their definition domain (this is to avoid boring repetitions of {\tt
% $v = \pre v$} statements).


\paragraph{Valuations.}
A \emph{valuation}
is a mapping from variables to values.
%
A \emph{data-context} is a pair $(\sigma_i, \sigma_p)$, where
$\sigma_i$ (input valuation) associates a value with each input,
and $\sigma_p$ (previous valuation) associates a value
with each previous variable. Previous valuations are also called
{\em data-state}. In particular, the default values of
variables are defining the {\em initial data-state}, denoted by
$\sigma_p^0$.


\paragraph{Formula.} A formula is any well-typed Boolean expression 
made of variables, constants, and classic
logical and numerical operators
({$\scriptstyle \neg, \wedge, \vee, =, >, <, \ge, \le, +, -, *, /$}).
We note $\FS$ the set of well-typed formula.

% Given a data-context, any formula can be reduced to a formula over
% the controllable variables ($V_o \uplus V_l$). 


% The notation \mbox{$(\sigma_i, \sigma_p): (\sigma_o, \sigma_l)
%   \models f$} states that, given a context $(\sigma_i, \sigma_p)$,
% the controllable valuation $(\sigma_o, \sigma_l)$ satisfies $f$.

 
%\paragraph{States, transitions, constraints and weights.}

\paragraph{Control structure.}
At the top level, the behaviour of a system is described by a
non-empty set of concurrent \WTS\ sharing the same variables.  Each
\WTS\ is an interpreted automaton, where transitions are labelled by
qualitative and stochastic constraints, as presented in the sequel.


\paragraph{control states.}
The set of \emph{control-states}, is divided into
\emph{stable} states and \emph{transient} states: $Q = Q_s \uplus
Q_t$. The initial control state is a particular stable state $q^0
\in Q_s$.


\paragraph{Weights.}
Weights are positive numerical functions of the uncontrollable
variables: $\Wgt: \Sigma_i \times \Sigma_p \rightarrow \integer \cup
\{\infty\}$.  More concretely, they are given as numerical
expressions made of inputs, previous variables, classical operators
or predefined computable functions.  The $\infty$ value is introduced
to express a sound notion of mandatory choice: a transition with the
infinite weight has priority on any finite weighted transition. There
is a single notion of infinite weight: two feasible transitions with
infinite weight have the same probability.
%If one wants to express relative probabilities
%between several mandatory choices, he must use transient states to detail
%the control structure.
In order to express relative probabilities between 
mandatory choices, it is necessary to detail 
the control structure by introducing transient states.


\paragraph{Transitions.}
The set of transitions is a relation:
$T \subseteq Q \times \FS \times \Wgt \times Q$,
and we note $q \transition{f}{w} q' \in T$ a transition from $q$
to $q'$ labelled by the formula $f$ and the weight $w$.  

Note that 2 transitions can have the same origin and the same target.
Note also that at most one outgoing transition can have an infinite
weight -- which not really a restriction since an equivalent
automaton can be written using transient states, eg, 
$\{ q_1 
\transition{f}{\infty} q_2,q_1 \transition{f}{\infty} q_2, ...\}
\equiv \{ q_1 \transition{f}{\infty} q', q' \transition{f}{w_1} q_2, 
q' \transition{f}{w_2} q_2, ... \}
$.





\paragraph{Transitional loops.}
We do not try to give sense to infinite loops of transient control states:
models containing such combinational loops are statically rejected.
 
\subsection{Operational  Semantics}
%\subsubsection{Simulation algorithm}

The \USMM\ are defined in such a way that their operational semantics
is straightforward. In some sense, they are {\em executable} by
definition. We give here the main lines of the simulation
algorithm.



In the sequel, we suppose that we have a single automaton,
obtained with one of the product operations defined above.
Note that, in the concrete implementation, the global product is
not statically built: local products are simply build {\em on the fly}
to avoid space state explosion.


\paragraph{\bf Execution.}
A \emph{Lucky program execution}, according to 
a given input history $(\nu^n)_{n \geq 0}$
is a sequence of pairs made of a stable 
state and a valuation: $(s^n, \sigma^n)_{n \geq 0} \in \integer
\rightarrow Q_s \times \Sigma$, such that:
\begin{itemize}
\item $s^0$ is the initial control state and $\sigma^0_p$ is the default
map of the variables,
\end{itemize}

and for each $k$:

\begin{itemize}
\item $\sigma^k_i = \nu^k$ (the valuation history meets the input history) 
\item $\sigma^{k}_{\setminus p} = \sigma^{k+1}_p$
(the current-part of the valuation meets the previous-part of the next
valuation)
\item $(s^k,\sigma^k_p,\sigma^k_i) \simpletrans{\sigma^k_o,\sigma^k_l} s^{k+1}$
is a feasible, fair reaction according to the control structure. We detail
in the sequel the algorithm for finding such a reaction.
\end{itemize}
\newcommand{\WF}{\mbox{$w$}}
\newcommand{\FF}{\mbox{$f$}}


\paragraph{\bf Reaction.}
Intuitively, a step in an execution is done by drawing, according to
weight directives and current values of uncontrollable
variables, a path in the automaton from the current
(stable) state to a next stable state.
More formally, let $s = q_0$ be the current control-state,
$\sigma_p$ the current data-state and $\sigma_i$ the current inputs.
For all $k$, we note $\Theta_k = \{ q_k \transition{f}{w} q\}$ the
set of transitions leaving $q_k$, and we use the notation
$\WF_\tau$ to denote the weight attached to a transition $\tau$.
According to the current data context, the sum of weights
$W_k = \sum_{\tau \in \Theta_k} \WF_\tau(\sigma_p,\sigma_i)$ is
a numerical constant. 
If there exist some transition $\tau$ from $q_k$ to $q_{k+1}$,
the probability to complete a path $(q_0, q_1, ..., q_k)$ with $q_{k+1}$ 
is then: $\WF_\tau(\sigma_p,\sigma_i) / W_k$.
This process is repeated until a stable state $q_n = s'$ is reached:
$s \transition{f_1}{w_1} q_1 \transition{f_2}{w_2} q_2 \cdots
q_{n-1} \transition{f_n}{w_n} s'$, where all
$q_1, \cdots q_{n-1}$ are transient.

The conjunction of all formulas labelling the drawn path is the
elected formula: $f={\overset{n}{\underset{k=1}{\wedge}}} f_k$.
We substitute in $f$ input and previous variables ($f_{|\sigma_i
  \sigma_p}$), and solve it. A valuation of output and local
variables for the current step is obtained by performing a fair toss
among the solutions of that formula.
If $f_{|\sigma_i \sigma_p}$ is unsatisfiable, another path is drawn.
If no satisfiable path can be drawn, the machine stops.

% As it is presented, this algorithm is quite ineffective, and,
% moreover it may diverge if no particular precaution is taken to avoid
% trying several times the same infeasible path.  

Note that infeasible paths are detected as soon as possible (by
marking them) to avoid divergence.


%--------------------------------------------------------------------

\subsection{A Lucky program Example}
\label{Example}

% We illustrate its use on an example of Figure~\ref{windows-automata}.


\begin{figure}[h]
  \begin{center}
%\vspace{-2cm}
\scalebox{0.9}{\input{objs/windows}}
\end{center}

 $V_i=\{ On, T \}$,
 $V_o=\{ t \}$,
 $V_l=\{ \delta, \cpt \}$,
 $V_p=\{ \pre t, \pre \cpt \}$,
 $Q_s = \{ \mathit{S_{on}}, \mathit{S_{off}}, \mathit{S_{open}} \}$,
 $q_0 = \mathit{S_{on}}$.
%\vspace{-8mm}
\caption{A Lucky program that simulates the temperature in a room with a heater and a window.}
\label{window-automata}
\label{windows-automata}
\end{figure}

The automaton of Figure~\ref{window-automata} represents a Lucky program
that models the temperature in a room containing a heater and a
window which is opened from times to times.  The version of this
automaton given in Lucky concrete syntax is provided in
Section~\ref{window-concrete}.  Input variables are a Boolean $On$,
which is true if the heater in on, and a real $T$, which indicates
the temperature outside the room.
%
The only output variable is a real $t$, indicating the
temperature inside the room.
%
Local variables are the real $\delta$, which is used to compute
the new temperature, and the integer $\cpt$, which is used to count
the number of steps the window remains open.
% 
Previous variables are $\pre t$ and $\pre \cpt$.
%
Stable states are denoted by $\mathit{s_{on}}$, $\mathit{s_{off}}$, and
$\mathit{s_{open}}$. The other unnamed states are transient. 
The initial state is $\mathit{s_{on}}$.  

If the heater is Initially on (resp. off), only 2 transitions are
possible among the 3 output transitions of $\mathit{s_{on}}$,
since the transition labelled by $\neg On$ (resp. $On$) is unsatisfiable.
The first possible transition has weight 100, and the other one has
weight 1.
\begin{itemize}
\item The first transition will therefore be drawn with a probability
  of $100/101$. It leads to a transient state which has only one
  output transition leading back to $\mathit{s_{on}}$ (resp.
  $\mathit{s_{off}}$); the elected formula is therefore $0<\delta<0.2
  \wedge t=\pre t + \delta$. It states that the local variable
  $\delta$ will be uniformly drawn between $0$ and $0.2$ (resp.
  $-0.1$ and 0), and that $\delta$ is then used to increase the
  temperature.  This is intended to model that, when the heater is on
  (resp. off), the temperature slightly increases (resp. decreases).
\item The second transition will be drawn with a probability of
  $1/101$. After two transient states, the only stable
  state that is reachable is $\mathit{s_{open}}$, and the
  elected formula is therefore $true \wedge 10 \leq \cpt \leq 15 \wedge
  t=\frac{3 \pre t + T}{4}$.  It states that the local integer
  variable \cpt\ is drawn uniformly between 10 and 15, and defines
  how the new temperature is computed.  This is intended to model
  that, whenever the window is open, the temperature becomes closer
  from the temperature outside.
  
  For the next step, from $\mathit{s_{open}}$, 3 transitions are
  possible, but they are labelled by formulas that can not be true at
  the same time (they form a partition): as long as \cpt\ is
  greater than 0, the window will remain open; \cpt\ is
  decremented at each step, and when it reaches 0, the control 
  gets back to either $\mathit{s_{on}}$ or $\mathit{s_{off}}$, depending
  on the variable $On$.
\end{itemize}
 

The concrete syntax version of this Lucky automata is given in
Section~\ref{window-concrete}.


%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\input{lucky-syntax}

%---------------------------------------------------------------------
%---------------------------------------------------------------------
\newpage
\section{Calling external code}
\label{building-dynlib}

In order to use external code from Lucky, we provide a mechanism based
on dynamic libraries. 
%
Such dynamic libraries should be built and used according to certain
conventions that we describe in this section.
%
Moreover, the type of imported functions should be declared in the
Lucky file (cf Section~\ref{syntax-dynlib}). And of course, the
declared types should match their definitions in the library. \\

{\bf BEWARE: } if the types you declare in the Lucky file does not
match their definitions, it might run silently returning wrong values!



% The syntax to declare external functions and use them is described
% in Section~\ref{syntax-dynlib} and~\ref{expressions}.


\subsection{Current restrictions}


\begin{itemize}

\item Imported code can only be functions over integers and doubles.

\item At least one and at most five arguments are required.

\item There is an issue with integers as Lucky manipulates integers
coded on 31 bits, not 32 bits. Therefore make sure you use only
integers between -1073741824 and 1073741823.  This may be changed in
future versions.

\todo{Add  \code{--int32} and \code{--int64} options.}

\end{itemize}



A example is given in the appendix~\ref{dyn_call_ex}. This exemple
(plus the Makefile) is also provided in the distribution in the
\code{demo-lucky/external\_code} directory. \\


\bug: \code{x = f(y) and z=g(x)} is not equivalent to \code{z =
g(f(y))}, because in the former case Lucky raises an error as it
believes that \code{x} is not bound.


\subsection{External code with side-effects}

Currently, external function call does not work very well if such
calls are doing side-effects.
%
For instance, the following code:

\begin{alltt}
  if 5 > random_up_to(10) then ... else
  if 5 > random_up_to(10) then ... else ...
\end{alltt}

is not equivalent to:

\begin{alltt}
  if   5   > random_up_to(10) then ... else
  if (4+1) > random_up_to(10) then ... else ...
\end{alltt}

because in the former case, the call to the function \code{rand\_up\_to} is
done once, while it is done twice in the latter case. This (buggy)
behaviour migth be fixed in future versions.

% 
% pb 2 : External code with SE and thickness ...
%
% pas vraiment un pb ca en fait.



%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage
\section{Numeric solver issues}
\label{lucky-numeric-solver}

Since we target the test of real-time software, we put the emphasis
on the efficiency of the solver.


In order to solve numeric linear constraints, we use the library of
convex polyhedron polka~\cite{polka} which is reasonably efficient,
at least for small dimension of manipulated polyhedra -- the
complexity of the algorithms are exponential in the dimension of
polyhedron. Polyhedron of dimension bigger that $15$ generally leads
to unreasonable response time.

Note however that independent variables -- namely, variables that do
not appear in the same constraint -- are handled in different
polyhedra. This means the limitation of 15 dimensions does not lead
to a limitation of 15 variables.


\subsection{Solving integer constraints in dimension $n \geq 2$}
When the dimension is greater than 2, for the sake of efficiency, we
do not use classical methods such as linear logic for solving integer
constraints: we solve those constraints in the domain of rational
numbers and then we truncate.  The problem is of course that the
result may not be a solution of the constraints. 

In such a case, we chose to pretend that the constraint is
unsatisfiable (after a few more tries according to various heuristics),
which can be wrong, but which is safe in some sense. The rigth solution there would
be to call an integer solver, which is very expensive, and yet to be done.

\todo{implement an {--int-solver} option that make Lucky use an integer solver when the polyhedron-based approach fails}

\subsection{Fairness versus efficiency}

Lucky (and Lurette) can be run in two different modes; one that emphasises
the fairness of the draw; the other one that emphasises the efficiency. 
Indeed, suppose we want to solve the following constraint:

$$ ((b \wedge \alpha_1) \vee (\overline{b} \wedge \alpha_2)) \wedge \alpha_3 \wedge (\alpha_4 \vee \alpha_5) $$

where $b$ is a Boolean, and where $\alpha_i$ are atomic numeric
constraints of the form: $\sum_i a_i x_i < cst$.  The first step is to
find solution from the Boolean point of view. This leads to the four solutions:

$$ b \alpha_1 \overline{\alpha_2} \alpha_3 \overline{\alpha_4} \alpha_5, \ \ \ \
 b \alpha_1 \overline{\alpha_2} \alpha_3 \alpha_4 \overline{\alpha_5}, \ \ \ \
 \overline{b} \overline{\alpha_1} \alpha_2 \alpha_3 \overline{\alpha_4} \alpha_5, \ \ \ \ 
 \overline{b} \overline{\alpha_1} \alpha_2 \alpha_3 \alpha_4 \overline{\alpha_5}$$

\noindent
Now, suppose that:
$$\alpha_1 = 100 > x, \ \
\alpha_2 = 200 > x, \ \
\alpha_3 = x > 0, \ \
\alpha_4 = x > x, \ \
\alpha_5 = x > 1$$

\noindent
 where $x$ an integer variable that has to be generated
by Lucky. We use the convex polyhedron library to solve the numeric constraints,
which lead respectively to the following sets of solutions:

$$S1 = b \wedge x \in [2;100]; \ \ 
S2 = b \wedge x = 0; \ \ 
S3 = b \wedge \overline{x} \in [2;200]; \ \ 
S4 = b \wedge \overline{x} = 0 $$


In order to perform a fair draw among the set of all solutions, we
need to compute the number of solutions in each of the set $Si$. But
this computation is very very expensive for polyhedron of big dimension.
Moreover, as we use Binary Decision Diagrams~\cite{cudd} to solve the
Boolean part, associating a volume to each numeric part results in a
lost of sharing in BBDs.

Therefore, we have  adopted a pragmatic approach:
\begin{itemize}
\item implement an efficient mode that is fair with respect to the Boolean part only; 
\item implement a fair mode that performs an approximation of the polyhedron volume.
\end{itemize}

The polyhedron volume is approximated by the smallest hypercube
containing the polyhedron.  Note that this leads to no approximation
for polyhedron of dimension 1 (intervals), and reasonable
approximation in dimension 2. But the error made increases
exponentionally in the dimension.
%
Therefore, for polyhedron of big dimension, it is better to use the
efficient mode, and to rely only the probability defined by
transition weights.



Note that when there are only Boolean variables as output or local
variables, the two modes are completely equivalent.

\subsection{Fair mode and precision and the computations}

In the fair mode, we compute an approximation of polyhedron volume.
But how to mix set of solutions that involves both integers and
floats (which are necessarily computed by distinct polyhedra)?

The solution we have adopted is the following: relate both domain via
the precision of the computations, which is a parameter of Lucky and
Lurette. For example, with a precision of 2 digit after the dot, 
we condiser that the set $x \in [0;3]$ contains $300$ solutions.


%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage
\section{The Lucky file interpreter}
\label{lucky-command-line}

The Lucky drawing engine is the main component of the Lurette testing
tool~\cite{lurette98,lucky-man,lurette-user}. However, we, at
Verimag, also provide an unpluggled version of this engine under the
form of a command-line Lucky file interpreter. Its work on PC/Linux,
Sun/Solaris, and PC/Windows-cygwin. Its usage is summarised in
Figure~\ref{lucky-usage}.


\begin{figure}[htb]
\begin{alltt}
usage: lucky [options]* (<file.luc>)+ 
   where `<file.luc> contains a Lucky program. Automata 
   that share output variables are executed as if they were 
   multiplied.
 
   options: 
 
  --boot, -boot, -b
	The Lucky machine starts generating values.
  --with-seed, --seed, -seed
	Set the value of the seed the random engine is initialized with.
  --step-number, -l
	Set a bound on the number of steps to perform.
  --precision, -precision, -p
	Set the precision used for numerical values (number of digits).
  --step-inside
	Draw inside the convex hull of solutions.
  --step-edges
	Draw inside the convex hull of solutions, but a little bit more 
        at edges and vertices.
  --step-vertices
	Draw among the vertices of the convex hull of solutions.
  --show-aut, -s
	Run lucky showing the lucky automata.
  --locals, -locals, -loc
	Shows local variables.
  --oracle, -oracle
	Launch an oracle (replace blank by '+', e.g., --oracle ecexe+f.ec).
  --fair, --compute-poly-volume
	Compute the polyhedra volume before drawing: more fair, but more expensive.
  --verbose, -verbose, -v
	Set on a verbose mode.
  --pre-processor, -pp
	Pipe lucky file(s) through a preprocessor (e.g., cpp).
\end{alltt}
\caption{The lucky file command-line interpreter usage}
\label{lucky-usage}
\end{figure}



%--------------------------------------------------------------------
%--------------------------------------------------------------------


\input{english.macros}
\bibliographystyle{alpha}
\bibliography{mycommontex}

%--------------------------------------------------------------------
\newpage
\appendix


%--------------------------------------------------------------------
%--------------------------------------------------------------------
%--------------------------------------------------------------------
\section{More Lucky program Examples}

% generated with the script luckytolatex



\subsection{The Lucky program of Figure~\ref{windows-automata}}
\label{window-concrete}
\begin{alltt}
  \input{window}
\end{alltt}



\newpage
\subsection{Illustration of the use of Polyhedra}
\begin{alltt}
\input{triangle_luc}
\end{alltt}


\begin{center}
\scalebox{0.8}{\input{triangle}}
\scalebox{0.8}{\input{triangle_edges}}
\end{center}



\newpage
\subsection{Illustration of the use of infinite weights}
\begin{alltt}
\input{infinite_weight}
\end{alltt}


\newpage
\subsection{Illustration of the use of dynamic weights}
\begin{alltt}
\input{dynamic_weight}
\end{alltt}



\newpage
\subsection{Illustration of the use of structured types}
\begin{alltt}
\input{structured_type}
\end{alltt}

\newpage
\subsection{Illustration of the use of external function calls}
\label{dyn_call_ex}
\begin{alltt}
\input{call_external_c_code}
\end{alltt}




%--------------------------------------------------------------------
%--------------------------------------------------------------------
%--------------------------------------------------------------------
\newpage
\section{Automata Product}
\label{automata-product}

First of all, the behaviour which is in general expressed as a a set of
concurrent automata, is semantically equivalent to the one of
a single {\em product automaton}. Two different products are
defined, depending on the semantics chosen for weights composition
(Figure~\ref{para}).
The simplest one is almost a classical {\em synchronous product}:
\begin{itemize}
\item the global state space is the Cartesian product of the 
component state spaces;
the global initial state is the tuple of initial states;
a global state is stable if it is composed of stable states only.
\item the definition of global transitions is almost a classical
composition where constraints are combined with the $\wedge$ operator,
and weights with the $*$ operator. The only problem is to
enforce the synchronisation on stable states; 
we note $s_1,s_2$ stable states,
$t_1,t_2$ transient states and $q_1,q_2$ any states, so:
\begin{itemize}
\item $(s_1, s_2)\transition{f_1 \wedge f_2}{w_1 * w_2}(q_1, q_2)$ iff
$s_1\transition{f_1}{w_1}(q_1)$ and 
$s_2\transition{f_2}{w_2}(q_2)$
\item $(t_1, t_2)\transition{f_1 \wedge f_2}{w_1 * w_2}(q_1, q_2)$ iff
$t_1\transition{f_1}{w_1}(q_1)$ and 
$t_2\transition{f_2}{w_2}(q_2)$
\item $(s_1, t_2)\transition{f_2}{w_2}(s_1, q_2)$ iff
$t_2\transition{f_2}{w_2}(q_2)$, and symmetrically for $(t_1,s_2)$.
\end{itemize}
\end{itemize}

The second kind of ``product'' (as shown in Figure~\ref{para}c) is a
little bit tricky: the idea is to 
introduce, for each component, an additional {\em starting} transient state
$\hat{s}$ and an additional {\em waiting} transient state $\breve{s}$ 
for each stable state $s$. 
The global state space is then defined as the Cartesian 
product over the extended component state spaces.
The definition of initial and stable global states does not change.
The transitions are defined in such a way that each component 
performs its reaction in turn. We only give the rules where the first component
starts, the other case is similar:
\begin{itemize}
\item from a global stable state, the first
component may start while the other waits:
$(s_1, s_2)\transition{~}{~}(\hat{s}_1,\breve{s}_2)$, 
\item the starting component performs its first transition:\\
$(\hat{s}_1, \breve{s}_2)\transition{f_1}{w_1}(q_1,\breve{s}_2)$ 
iff $s_1\transition{f_1}{w_1}q_1$, 
\item the starting component is not yet in a stable state, and it performs
another transition: $(t_1, \breve{s}_2)\transition{f_1}{w_1}(q_1,\breve{s}_2)$ 
iff $t_1\transition{f_1}{w_1}q_1$,
\item the starting component has reached a stable state, and
the waiting one starts its reaction:
$(s_1, \breve{s}_2)\transition{f_2}{w_2}(s_1,q_2)$ 
iff $s_2\transition{f_2}{w_2}q_2$,
\item the second component performs transitions until it reaches
a stable state: $(s_1, t_2)\transition{f_2}{w_2}(s_1,q_2)$ 
iff $t_2\transition{f_2}{w_2}q_2$.
\end{itemize}






\end{document}
